from ost.bindings import dssp

m = io.LoadPDB('data/urease.pdb')
scene.bg = gfx.WHITE
g = gfx.Entity('G', gfx.SIMPLE, m)
g.SetOutline(True)
g.SetOutlineMode(3)
scene.Add(g)
gl = gfx.PrimList('pl')
#scene.Add(gl)


class StringOfBeads:
  def __init__(self, name, anchor_a, anchor_b, length, center):
    self.anchor_a = anchor_a
    self.anchor_b = anchor_b
    self.length = length
    self.center = center
    positions = self.Optimize()
    self.ent = mol.CreateEntity()
    edi = self.ent.EditXCS()
    ch = edi.InsertChain("A")
    last = None
    for pos in positions:
      res = edi.AppendResidue(ch, "X")
      print pos
      atm = edi.InsertAtom(res, "X", pos)
      if last:
        edi.Connect(atm, last)
      last = atm
    self.g = gfx.Entity(name, gfx.CUSTOM, self.ent)
    self.g.SetColor(gfx.RED)
    self.g.custom_options.SetBondRad(0.1)
    scene.Add(self.g)

  def Optimize(self):
    d = self.anchor_b - self.anchor_a
    positions = [self.anchor_a+i*0.05*d for i in range(21)]
    len0 = self.length/20
    dt = 0.01
    for k in range(1000):
      forces = [2*geom.Normalize(p-self.center) for p in positions]
      for i in range(1, 20):
        dir1 = positions[i-1]-positions[i]
        len1 = geom.Length(dir1)
        dir1/=len1
        dir2 = positions[i+1]-positions[i]
        len2 = geom.Length(dir2)
        dir2/= len1
        forces[i]+= 10*dir1* (len1-len0)
        forces[i]+= 10*dir2* (len2-len0)
      for i in range(1, 20):
        positions[i]+=dt*forces[i]
    return positions
  
print 'optimizing string of beads for Xlinks. This will take a while...'
for i, line in enumerate(open('data/crosslinks-12.txt')):
  split = line.split()
  a1 = split[2].split('-')
  aa1 = m.FindAtom(a1[2], int(a1[1]), 'CA')
  a2 = split[3].split('-')
  aa2 = m.FindAtom(a2[2], int(a2[1]), 'CA')
  sof = StringOfBeads(str(i), aa1.pos, aa2.pos, 12, m.geometric_center)

for i, c in enumerate(m.chains):
  if i<12:
    g.SetColor(gfx.RGBA(0,0.501961,0.25098,1), 'cname=%s' % c.name)
  elif i<24:
    g.SetColor(gfx.RGBA(0,0.25098,0.501961,1), 'cname=%s' % c.name)
  elif i<36:
    g.SetColor(gfx.RGBA(0.4,0.4,0.4,1), 'cname=%s' % c.name)

